﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;

namespace CustomTickersTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Point> data = new ObservableCollection<Point>{
        new Point(0,1),
        new Point(1,1),
        new Point(2,1),
        new Point(3,1),
        new Point(4,1),
        new Point(5,1),
        new Point(6.11111,1),
        new Point(7,1),
        new Point(8,1),
        new Point(9,1),
        new Point(10,1),
        new Point(11,1),
        new Point(12.5,1),
        new Point(13,1),
        new Point(14,1),
        new Point(50,1)
        };

        public MainWindow()
        {
            InitializeComponent();
        }

        private void OnLoaded(object sender, RoutedEventArgs e)
        {
            var tickmarks = GenerateCustomTickmarksFromSuppliedData();

            FindValuesWhichShoudNotHaveLabels(tickmarks, .05);

            var series = new ScatterLineSeries
            {
                Brush = Brushes.Red,
                Thickness = 1,
                XAxis = xAxis,
                YAxis = yAxis0,
                XMemberPath = "X",
                YMemberPath = "Y",
                MarkerType = MarkerType.None,
                ItemsSource = this.data
                
            };

            this.DataChart.Series.Add(series);
            
            xAxis.TickmarkValues = new CustomTickmarkValues(tickmarks);
        }

        private DoubleCollection GenerateCustomTickmarksFromSuppliedData()
        {
            var tickmarks = new DoubleCollection();

            foreach(var point in data)
            {
                tickmarks.Add(point.X);
            }
            return tickmarks;
        }

        private void FindValuesWhichShoudNotHaveLabels(DoubleCollection doubles, double partialDelta)
        {
            var valuesToBypass = new DoubleCollection();

            if(doubles != null && doubles.Count > 0)
            {
                double previous = double.MinValue;
                double max      = doubles.Max();
                double delta    = max * partialDelta;

                for(int i = 0; i < doubles.Count; i++)
                {
                    if(i == 0)
                    {
                        previous = doubles[i];

                        continue;
                    }

                    if(doubles[i] - previous < delta)
                    {
                        valuesToBypass.Add(doubles[i]);
                    }
                    else
                    {
                        previous = doubles[i];
                    }
                }
            }

            SpecialConverter.ValuesToBypass = valuesToBypass;
        }

        private void OnClick(object sender, RoutedEventArgs e)
        {
            System.Diagnostics.Debugger.Break();
        }
    }
}
